searchNodes=[{"doc":"Process adapter to handle singleton processes in Elixir applications. The problem Sometimes, when yo start your program on cluster with MASTER&lt;-&gt;MASTER strategy, some of your modules should be started only on one nod at a time. The should be registered within :global module, but :global doesn't handle name conflicts and restarts. This is what Individual for. Usage Wrap your worker or supervisor specification inside any of your supervisors with Individual call, passing supervisor specification as argument for Individual . Your worker or supervisor should be registered within :global module. Examples # Simple call: def start ( _type , _args ) do Supervisor . start_link ( [ { Individual , MyModule } ] , strategy : :one_for_one , name : Individual.Supervisor ) end # Call with args: def start ( _type , _args ) do Supervisor . start_link ( [ { Individual , { MyModule , %{ foo : :bar } } } ] , strategy : :one_for_one , name : Individual.Supervisor ) end # To start multiple processes with same name: def start ( _type , _args ) do Supervisor . start_link ( [ { Individual , Supervisor . child_spec ( { MyModule , [ ] } , id : Test1 ) } , { Individual , Supervisor . child_spec ( { MyModule , [ ] } , id : Test2 ) } ] , strategy : :one_for_one , name : Individual.Supervisor ) end","ref":"Individual.html","title":"Individual","type":"module"},{"doc":"This function will start your module, monitored with Individual . It requires your module's specification, the same you pass into any of your supervisors. Examples Individual . start_link ( MyModule ) Individual . start_link ( { MyModule , [ 1 , 2 , 3 ] } ) Individual . start_link ( MyModule . child_spec ( :foobar ) )","ref":"Individual.html#start_link/1","title":"Individual.start_link/1","type":"function"},{"doc":"","ref":"Individual.html#t:child_spec/0","title":"Individual.child_spec/0","type":"type"},{"doc":"This registry is a build-up upon global registry. We'll use it for better conflicts resolution.","ref":"Individual.Registry.html","title":"Individual.Registry","type":"module"},{"doc":"This module wraps underlying workers, that can not be registered in :global scope. The problem Worker can not register it's name by default, so we need wrapper, that would be registered inside global module for that purposes. Solution So, Individual will monitor Individual.Wrapper , which will be unique across cluster. Wrapper will monitor underlying module. If Individual.Wrapper will not be able to start because of name conflict, underlying module will even not try to start. When one of the cluster nodes will fall, Individual modules on all other nodes will try to start there own Individual.Wrapper 's. The first one, that will be started - will continue to work, and will start underlying module. All other will fail because of name conflicts.","ref":"Individual.Wrapper.html","title":"Individual.Wrapper","type":"module"},{"doc":"","ref":"Individual.Wrapper.html#handle_call/3","title":"Individual.Wrapper.handle_call/3","type":"function"},{"doc":"This function will be called by Individual module. No need to call it manually","ref":"Individual.Wrapper.html#start_link/1","title":"Individual.Wrapper.start_link/1","type":"function"},{"doc":"","ref":"Individual.Wrapper.html#time_alive/1","title":"Individual.Wrapper.time_alive/1","type":"function"},{"doc":"Copyright (c) 2017 Dmitry Rubinstein Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Process adapter to handle singleton processes in Elixir applications.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Sometimes, when you start your program on cluster with MASTER&lt;-&gt;MASTER strategy, some of your modules should be started only on one node at a time. This is common pattern, which is called CLUSTER SINGLETON . These modules can be thus be registered within :global module, but :global doesn't handle name conflicts and restarts.","ref":"readme.html#the-problem","title":"Overview - The problem","type":"extras"},{"doc":"Individual will cover working with :global module by itself. It will ensure, that ONLY one defined module at a time is working on a cluster, and also will restart the process on another node in node with working process will fail.","ref":"readme.html#solution","title":"Overview - Solution","type":"extras"},{"doc":"If the cluster is starting in the same time, Individual will give time gape of 5 seconds. Within it, every node has the same probability to become a leader. After 5 seconds gap, oldest node will always be a leader. This solution should prevent the situation, when node that is added to the cluster can kill already working processes to restart the by nodeself.","ref":"readme.html#default-name-conflicts-resolution","title":"Overview - Default name conflicts resolution","type":"extras"},{"doc":"Since Individual uses :global module, there is a common problem with cluster splits . In this case, each part of previous stable cluster will have it's own process, thus this process stops to be singleton . In current implementation, Individual does not resolve this problems for you, you should resolve them by yourself. ( If you have great ideas of doing this - welcome to your PRs to this repo! )","ref":"readme.html#split-brain-resolution","title":"Overview - Split Brain Resolution","type":"extras"},{"doc":"Wrap your worker or supervisor specification inside any of your supervisors with Individual call, passing supervisor specification as an argument for Individual . Your worker or supervisor can register itself with some name or not - Individual will take care about registering it in a global scope.","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"# Simple call: def start ( _type , _args ) do Supervisor . start_link ( [ { Individual , MyModule } ] , strategy : :one_for_one , name : Individual.Supervisor ) end # Call with args: def start ( _type , _args ) do Supervisor . start_link ( [ { Individual , { MyModule , %{ foo : :bar } } } ] , strategy : :one_for_one , name : Individual.Supervisor ) end # To start multiple processes with same name: def start ( _type , _args ) do Supervisor . start_link ( [ { Individual , Supervisor . child_spec ( { MyModule , [ ] } , id : Test1 ) } , { Individual , Supervisor . child_spec ( { MyModule , [ ] } , id : Test2 ) } ] , strategy : :one_for_one , name : Individual.Supervisor ) end","ref":"readme.html#examples","title":"Overview - Examples","type":"extras"},{"doc":"iex -- name a @ 127.0 . 0.1 - S mix iex -- name b @ 127.0 . 0.1 - S mix ...","ref":"readme.html#starting-cluster","title":"Overview - Starting cluster","type":"extras"},{"doc":"0.3.2 Fixing bug with strategies Fixing bug with pid logging 0.3.1 ENHANCEMENTS Adding Individual.Registry , that proxies :global module calls. It will prevent process recreation if the node was just added to working cluster. 0.2.1 ENHANCEMENTS Adding Individual.Wrapper module, that allows to control GenServer, that don't register themselves in :global scope. 0.1.1 ENHANCEMENTS Beautifying observer 's output","ref":"readme.html#changelog","title":"Overview - Changelog","type":"extras"},{"doc":"The package can be installed by adding :individual to your list of dependencies in mix.exs : def deps do [ { :individual , &quot;~&gt; 0.3&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Copyright (c) 2017 Dmitry Rubinstein This work is free. You can redistribute it and/or modify it under the terms of the MIT License. See the LICENSE.md file for more details.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]